var altitude_ft_Node = props.globals.getNode("position/altitude-ft", 1);
var airspeed_kt_Node = props.globals.getNode("velocities/airspeed-kt", 1);
var ground_elevation_ft_Node = props.globals.getNode("position/ground-elev-ft", 1);
var antigrav = { input_type: 0, momentum_watch: 0, momentum: 0, up_factor: 0, request: 0, control_factor: 2 };
	# input_type ; 1 = keyboard, 2 = joystick(disabled), 3 = mouse
	# request = for during startup, includes timer to cancel request if no further requests are made. Returns to zero after complete.
	# control_factor = multiplier or power level from lever next to throttle, for VTOL movement
setlistener("controls/engines/countergrav-factor", func(n) { antigrav.control_factor = n.getValue() },, 0);

# mouse hover -------------------------------------------------------
#var KbdShift = props.globals.getNode("/devices/status/keyboard/shift");
#var KbdCtrl = props.globals.getNode("/devices/status/keyboard/ctrl");
var mouse = { savex: nil, savey: nil };
setlistener("/sim/startup/xsize", func(n) mouse.centerx = int(n.getValue() / 2), 1);
setlistener("/sim/startup/ysize", func(n) mouse.centery = int(n.getValue() / 2), 1);
setlistener("/sim/mouse/hide-cursor", func(n) mouse.hide = n.getValue(), 1);
#setlistener("/devices/status/mice/mouse/x", func(n) mouse.x = n.getValue(), 1);
setlistener("/devices/status/mice/mouse/y", func(n) mouse.y = n.getValue(), 1);
setlistener("/devices/status/mice/mouse/mode", func(n) mouse.mode = n.getValue(), 1);
setlistener("/devices/status/mice/mouse/button[0]", func(n) mouse.lmb = n.getValue(), 1);
setlistener("/devices/status/mice/mouse/button[1]", func(n) {
	mouse.mmb = n.getValue();
	if (mouse.mode)
		return;
	if (mouse.mmb) {
		controls.centerFlightControls();
#		mouse.savex = mouse.x;
		mouse.savey = mouse.y;
		gui.setCursor(mouse.centerx, mouse.centery, "none");
	} else {
		gui.setCursor(mouse.savex, mouse.savey, "pointer");
		antigrav.up_factor = 0;
		if (antigrav.momentum_watch > 0) {
			antigrav.momentum_watch -= 1;
		}
	}
}, 1);
setlistener("/devices/status/mice/mouse/button[2]", func(n) {
	mouse.rmb = n.getValue();
	if (antigrav.momentum_watch) {
		antigrav.up_factor = 0;
		antigrav.momentum_watch -= 1;
	}
}, 1);


mouse.loop = func {
	if (mouse.mode or !mouse.mmb) {
		return settimer(mouse.loop, 0);
	}
#	var dx = mouse.x - mouse.centerx;
	var dy = -mouse.y + mouse.centery;
	if (dy) {
		antigrav.input_type = 3;
		antigrav.up_factor = dy * 0.001;
		if (antigrav.momentum_watch < 1) {
			antigrav.momentum_watch = 3;
			coast_up(coast_loop_id += 1);
		}
		gui.setCursor(mouse.centerx, mouse.centery);
	}
	settimer(mouse.loop, 0);
}
mouse.loop();

# keyboard hover ----------------------------------------------------
setlistener("sim/model/hover/key-up", func(n) {
	var key_dir = n.getValue();
	if (key_dir) {	# repetitive input or lack of older mod-up may keep triggering
		antigrav.input_type = 1;
		antigrav.up_factor = (key_dir < 0 ? -0.01 : 0.01);
		if (antigrav.momentum_watch <= 0) {
			antigrav.momentum_watch = 3;	# start or reset timer for countdown
			coast_up(coast_loop_id += 1);	# starting from rest, start new loop
		} else {
			antigrav.momentum_watch = 3;	# reset watcher
		}
	} else {
		antigrav.momentum_watch -= 1;
		antigrav.up_factor = 0;
		if (antigrav.momentum_watch < 0) {
			antigrav.momentum_watch = 0;
		}
	}
});

var coast_loop_id = 0;
var coast_up = func (id) {
	id == coast_loop_id or return;
	if (antigrav.momentum_watch >= 3) {
		antigrav.momentum += antigrav.up_factor;
		if (antigrav.input_type == 3) {
			antigrav.up_factor = 0;
		}
		if (abs(antigrav.momentum) > 2.0) {
			antigrav.momentum = (antigrav.momentum < 0 ? -2.0 : 2.0);
		}
	} elsif (antigrav.momentum_watch >= 2) {
		antigrav.momentum_watch -= 1;
	} else {
		antigrav.momentum = antigrav.momentum * 0.75;
		if (abs(antigrav.momentum) < 0.02) {
			antigrav.momentum = 0;
			antigrav.momentum_watch = 0;
		}
	}
	if (antigrav.momentum) {
		up((antigrav.momentum < 0 ? -1 : 1), antigrav.momentum, antigrav.input_type);
	}
	if (antigrav.momentum_watch) {
		settimer(func { coast_up(coast_loop_id += 1) }, 0);
	} else {
		antigrav.momentum = 0;
	}
}

var up = func(hg_dir, hg_thrust, hg_mode) {  # d=direction p=thrust_power m=source of request
	var entry_altitude = altitude_ft_Node.getValue();
	var altitude = entry_altitude;
	var target_alt = ground_elevation_ft_Node.getValue() + 0.1;
	var asas = abs(airspeed_kt_Node.getValue());
	if (hg_mode == 1 or hg_mode == 3) {
		# 1 = keyboard , 3 = mouse
		var hg_rise = antigrav.momentum * antigrav.control_factor;
	} else {
		# 0 = gravity , 2 = joystick
		var hg_rise = hg_thrust * antigrav.control_factor * hg_dir;
	}
	var contact_rise = altitude + hg_rise;
	if (hg_dir < 0) {    # down requested by drift, fall, or VTOL down buttons
		if (contact_rise < target_alt) {  # too low
			contact_rise = target_alt;
		}
		if (!antigrav.request) {  # fall unless antigrav just requested
			altitude = contact_rise;
			altitude_ft_Node.setDoubleValue(altitude);
		}
	} elsif (hg_dir > 0) {  # up
		contact_rise = altitude + hg_rise;
		altitude = contact_rise;
		altitude_ft_Node.setDoubleValue(altitude);
	}
}


